///////////////////////////////////////////////
// Client Application (C++) for the Test DLL //
// By Nicholas Skapura						 //
// 17 February 2002							 //
///////////////////////////////////////////////


////////// Header Files //////////
#include <windows.h>
#include <iostream.h>
#include <conio.h>


////////// Function Prototypes //////////
// These are the prototypes for the functions declared in the DLL.
typedef void (WINAPI*cfunc)();
typedef int (WINAPI*ifunc)(short t);


////////// Function Locations //////////
cfunc TestSub;
ifunc SimpleFunc;


////////// Main Function //////////
void main()
{

	// Load the DLL into memory.
	HINSTANCE hLib = LoadLibrary("testdll_library.dll");

	// Make sure to check if it was loaded successfully.
	if(hLib == NULL)
	{
		cout << "ERROR: Unable to load library!" << endl;
		getch();
		return;
	}

	// Finds the path of the client application.
	char mod[50];
	GetModuleFileName((HMODULE)hLib,(LPTSTR)mod,50);
	cout << "Library Loaded: " << mod << endl;

	// Finds the addresses of all the DLL's functions.
	TestSub = (cfunc)GetProcAddress((HMODULE)hLib,"TestSub");
	SimpleFunc = (ifunc)GetProcAddress((HMODULE)hLib,"SimpleFunc");

	// Call the DLL functions through the function pointers.
	TestSub();
	cout << SimpleFunc(5) << endl;

	getch();

	// Free the DLL from memory.
	FreeLibrary((HMODULE)hLib);
}